
package monogram.plugin;

import java.io.File;

/**
 * @author University of Waikato - Te Whare Wānanga o Waikato
 * @version 1.0
 * @since   2014-11-20 
 */
public class PluginManager implements Plugin {

    private File tmpdir;

    public PluginManager(File tmpdir) {
        this.tmpdir = tmpdir;
    }

    public File run(PluginConfiguration fileView) throws UnsupportedOperationException, Exception {
        String fileType = fileView.getFileType();
        System.out.println("test 2");
        if (fileType.equalsIgnoreCase(".txt")) {
            System.out.println("test 3");
            return runPluginTXT(fileView);
        } else if (fileType.equalsIgnoreCase(".docx")) {
            return runPluginDOCX(fileView);
        } else if (fileType.equalsIgnoreCase(".odt")) {
            return runPluginODT(fileView);
        } else {
            throw new UnsupportedOperationException("Not supported yet.");
        }
    }

    private File runPluginTXT(PluginConfiguration fileView) throws Exception {
        Plugin plugin = new PluginTXT(tmpdir);
        System.out.println("test 4");
        return plugin.run(fileView);
    }

    private File runPluginDOCX(PluginConfiguration fileView) throws Exception {
        Plugin plugin = new PluginDOCX(tmpdir);
        return plugin.run(fileView);
    }

    private File runPluginODT(PluginConfiguration fileView) throws Exception {
        Plugin plugin = new PluginODT(tmpdir);
        return plugin.run(fileView);
    }
}
