/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package monogram.restorer;

import util.CharReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import util.CharacterUtil;
import util.IOUtil;

/**
 *
 * @author OEM
 */
public class XMLRestorer {

    private static final String OUTPUT_CHARSET_ENCODING = "utf-8";

    public XMLRestorer() {
        //default constructor
    }

    public void restore(File inputFile, String inputCharsetEncoding, File outputFile, boolean preserveMacrons) {
        MonogramRestorer restorer = new MonogramRestorer(preserveMacrons);
        final StringBuilder buffer = new StringBuilder();
        CharReader reader = null;
        BufferedWriter writer = null;
        try {
            reader = new CharReader(inputFile, inputCharsetEncoding);
            writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outputFile), OUTPUT_CHARSET_ENCODING));

            while (reader.hasNextChar()) {
                char peek = reader.peek();
                if (peek == '<') {
                    while (reader.hasNextChar()) {
                        char c = reader.nextChar();
                        writer.write(c);
                        if (c == '>') {
                            break;
                        }
                    }
                } else if (Character.isLetterOrDigit(peek)) {
                    buffer.setLength(0);
                    while (reader.hasNextChar() && Character.isLetterOrDigit(reader.peek())) {
                        buffer.append(reader.nextChar());
                    }
                    final String restoredToken = restorer.restore(buffer.toString());
                    writer.write(restoredToken);
                } else if (CharacterUtil.isPunctuation(peek)) {
                    final String restoredToken = restorer.restore(String.valueOf(reader.nextChar()));
                    writer.write(restoredToken);
                } else {
                    writer.write(reader.nextChar());
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            reader.close();
            IOUtil.closeWriter(writer);
        }
    }
}
