/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;

/**
 * Simple utility methods for IO operations.
 *
 * @author John Cocks
 */
public class IOUtil {

    /**
     * Closes the reader.
     * @param reader The reader to close.
     */
    public static void closeReader(Reader reader) {
        if (reader != null) {
            try {
                reader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * Closes the writer.
     * @param writer The writer to close.
     */
    public static void closeWriter(Writer writer) {
        if (writer != null) {
            try {
                writer.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * Converts the character set of a text file.
     * @param fileIn
     * @param charSetIn
     * @param fileOut
     * @param charSetOut
     * @return
     */
    public static boolean convertCharSet(File fileIn, String charSetIn,
            File fileOut, String charSetOut) {
        BufferedReader reader = null;
        BufferedWriter writer = null;
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream(fileIn), charSetIn));
            writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(fileOut), charSetOut));
            String line;
            while ((line = reader.readLine()) != null) {
                writer.write(line);
                writer.newLine();
            }
            return true;
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        } finally {
            closeReader(reader);
            closeWriter(writer);
        }
    }
}
