/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package web.servlets;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import monogram.plugin.PluginConfiguration;
import monogram.plugin.PluginManager;

/**
 *
 * @author OEM
 */
public class DirectInput extends HttpServlet {

    private final String UNEXPECTED_ERROR = "An unexpected error has occurred. Please try again or contact the web administrator if the problem persists.";
    private final String UTF8_ENCODING = "utf-8";
    public static boolean DI; // This will be used in a test in the mongramRestorer to add html to highligth the changes on the webpage output. 
    private File tmpdir;

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        tmpdir = new File((String) config.getServletContext().getAttribute("tmpdir"));
    }

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        request.setCharacterEncoding("utf-8");
        DI = true; 
        final String fragment = request.getParameter("fragment");
        final String lang = request.getParameter("lang");
        final String preserveMacrons = request.getParameter("preserveExistingMacrons") != null ? request.getParameter("preserveExistingMacrons") : "false";
        final String options = request.getParameter("options");
        final String path = "/jsp" + (lang.equals("en") ? "/en" : "/mi");
         //Write the input to a temporary file.
        File file = File.createTempFile("mi-tmp-", ".txt", tmpdir);
        write(file, "utf-8", fragment);

        //Create a fileview
        PluginConfiguration configuration = new PluginConfiguration();
        configuration.setFile(file);
        configuration.setCharsetEncoding("utf-8");
        configuration.setFileType(".txt");
        configuration.setPreserveExistingMacrons(preserveMacrons.equals("true"));
        //Restore the file.
        PluginManager pluginManager = new PluginManager(tmpdir);
        File restoredFile = null;
        try {
            System.out.println("test 1");
            restoredFile = pluginManager.run(configuration);
            //Read the file into a String then delete
             System.out.println("test done");
            String restoredFragment = read(restoredFile, "utf-8");
             
            request.setAttribute("fragment2", restoredFragment);
            request.setAttribute("old", fragment);
            request.setAttribute("options", options);
            request.setAttribute("preserveMacrons", preserveMacrons);
            RequestDispatcher dispatcher = this.getServletContext().getRequestDispatcher(path + "/main.jsp");
            dispatcher.forward(request, response);
        } catch (Exception e) {
           request.setAttribute("errorMessage", UNEXPECTED_ERROR);
           forward(path + "/error.jsp", request, response);
        } finally {
            file.delete();
            restoredFile.delete();
        }
    }

    /**
     * Forwards a request from a servlet to another resource on the server.
     * @param path Path to forward to.
     * @param request
     * @param response
     * @throws ServletException
     * @throws IOException
     */
    private void forward(String path, HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        final RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(path);
        dispatcher.forward(request, response);
    }

    /**
     * Writes the fragment to the file.
     * @param file The file to write to.
     * @param fragment The String to write to the file.
     */
    private void write(File file, String charsetEncoding, String fragment) {
        BufferedWriter out = null;
        try {
            out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file), charsetEncoding));
            out.write(fragment);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            close(out);
        }
    }

    /**
     * Reads the contents of the file.
     * @param file The file to read.
     * @param charsetEncoding The character set encoding of the file.
     * @return The contents of the file.
     */
    private String read(File file, String charsetEncoding) {
        final StringBuilder buffer = new StringBuilder();
        BufferedReader reader = null;
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream(file), charsetEncoding));
            final char[] chars = new char[1024];
            int numRead = 0;
            while ((numRead = reader.read(chars)) > -1) {
                buffer.append(String.valueOf(chars, 0, numRead));
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            close(reader);
        }
        return buffer.toString();
    }

    /**
     * Close the writer.
     * @param writer The Writer to close.
     */
    private void close(Writer writer) {
        if (writer != null) {
            try {
                writer.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * Close the reader.
     * @param reader The Reader to close.
     */
    private void close(Reader reader) {
        if (reader != null) {
            try {
                reader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
